#ifndef __AP_MANAGER_H__
#define __AP_MANAGER_H__

#include "ap-ability.h"
#include "ap-skill.h"
#include "ap-weapon.h"

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AP_TYPE_MANAGER (ap_manager_get_type ())

G_DECLARE_FINAL_TYPE (APManager, ap_manager, AP, MANAGER, GObject)

APManager *
ap_manager_new (void);

APManager *
ap_manager_get_default (void);

gboolean
ap_manager_add_ability (APManager *self,
                        APAbility *ability);

APAbility *
ap_manager_get_ability (APManager *self,
                        gchar     *name);

gboolean
ap_manager_remove_ability (APManager *self,
                           gchar     *name);

gboolean
ap_manager_add_skill (APManager *self,
                      APSkill   *skill);

APSkill *
ap_manager_get_skill (APManager *self,
                      gchar     *id);

gboolean
ap_manager_remove_skill (APManager *self,
                         gchar     *id);

GList *
ap_manager_get_abilities (APManager *self);

void
ap_manager_remove_abilities (APManager *self);

GList *
ap_manager_get_skills (APManager *self);

void
ap_manager_remove_skills (APManager *self);

void
ap_manager_remove_all (APManager *self);

G_END_DECLS

#endif /* __AP_MANAGER_H__ */

