#include "test-ability.h"
#include "test-manager.h"

#include <adventure-pack.h>

#include <glib.h>
#include <locale.h>

int
main (int    argc,
      char **argv)
{
    /*
    APAbility *ability;

    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "Strength",
                            "score", 15,
                            "bonus", 0,
                            NULL);

    gchar *name = ap_ability_get_name (ability);

    g_print ("name: %s\n", name);

    g_free (name);

    g_object_unref (ability);
    */

    /*
    APManager *manager;
    APCharacter *character;
    APAbility *ability;
    APSkill *skill;
    APAttack * attack;

    manager = ap_manager_get_default ();

    character = ap_character_new ();

    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "Strength",
                            "score", 15,
                            "bonus", 0,
                            NULL);

    ap_manager_add_ability (manager, ability);
    ap_character_add_ability (character, ability);
    ap_ability_set_score (ability, 10);

    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "Dexterity",
                            "score", 5,
                            "bonus", 0,
                            NULL);

    ap_manager_add_ability (manager, ability);
    ap_character_add_ability (character, ability);

    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "Wisdom",
                            "score", 10,
                            "bonus", 0,
                            NULL);

    ap_manager_add_ability (manager, ability);
    ap_character_add_ability (character, ability);

    skill = g_object_new (AP_TYPE_SKILL,
                          "id", "acrobatics",
                          "name", "Acrobatics",
                          "modifier", "dexterity",
                          "bonus", 0,
                          "proficient", TRUE,
                          NULL);

    ap_manager_add_skill (manager, skill);
    ap_character_add_skill (character, skill);

    skill = g_object_new (AP_TYPE_SKILL,
                          "name", "Animal Handling",
                          "modifier", "Wisdom",
                          "bonus", 0,
                          "proficient", FALSE,
                          NULL);

    ap_manager_add_skill (manager, skill);
    ap_character_add_skill (character, skill);

    attack = g_object_new (AP_TYPE_ATTACK,
                           "name", "Slash",
                           "type", "slash",
                           "damage", 10,
                           "critical", 20,
                           "range", 1,
                           "ammo", 0,
                           "bonus", 0,
                           NULL);

    ap_character_add_attack (character, attack);

    ap_character_print (character);

    g_print ("\n");

    ability = ap_manager_get_ability (manager, "dexterity");
    ap_ability_set_score (ability, 15);

    ap_character_print (character);

    g_print ("\n");

    // Clean-up
    // Will unref all abilities & skills attached
    g_object_unref (manager);
    */
    /*
    ap_manager_remove_ability (manager, "strength");
    ap_manager_remove_ability (manager, "dexterity");
    ap_manager_remove_ability (manager, "wisdom");
    ap_manager_remove_skill (manager, "acrobatics");
    ap_manager_remove_skill (manager, "animal-handling");
    */
    /*
     * *************************************************************************
     * Prepare Test
     * *************************************************************************
     */
    setlocale (LC_ALL, "");

    g_test_init (&argc, &argv, NULL);
    g_test_bug_base ("https://github.com/adventure-pack/libadventure-pack/issues");

    /*
     * *************************************************************************
     * Ability Test
     * *************************************************************************
     */
    g_test_add ("/ability/name", AbilityFixture, NULL,
                ability_fixture_set_up,
                test_ability_name,
                ability_fixture_tear_down);

    g_test_add ("/ability/score", AbilityFixture, NULL,
                ability_fixture_set_up,
                test_ability_score,
                ability_fixture_tear_down);

    g_test_add ("/ability/score-with-bonus", AbilityFixture, NULL,
                ability_fixture_set_up,
                test_ability_score_with_bonus,
                ability_fixture_tear_down);

    for (gint i = 1; i <=  30; i++)
    {
        /*
         * test_name = /ability/modifier/$i
         */
        gchar *test_name = g_strconcat ("/ability/modifier/", g_strdup_printf ("%i", i), NULL);

        g_test_add (test_name, AbilityFixture, GINT_TO_POINTER (i),
                    ability_fixture_set_up,
                    test_ability_modifier,
                    ability_fixture_tear_down);
    }

    g_test_add ("/ability/signal/score-changed", AbilityFixture, NULL,
                ability_fixture_set_up,
                test_ability_signal_score_changed,
                ability_fixture_tear_down);

    g_test_add ("/ability/signal/modifier-changed", AbilityFixture, NULL,
                ability_fixture_set_up,
                test_ability_signal_modifier_changed,
                ability_fixture_tear_down);

    /*
     * *************************************************************************
     * Manager Test
     * *************************************************************************
     */
    g_test_add ("/manager/ability/add", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_ability_add,
                manager_fixture_tear_down);

    g_test_add ("/manager/ability/add-with-no-name", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_ability_add_with_no_name,
                manager_fixture_tear_down);

    g_test_add ("/manager/ability/add-with-duplicate-name", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_ability_add_with_duplicate_name,
                manager_fixture_tear_down);

    g_test_add ("/manager/ability/get", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_ability_get,
                manager_fixture_tear_down);

    g_test_add ("/manager/skill/add", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_skill_add,
                manager_fixture_tear_down);

    g_test_add ("/manager/skill/add-with-no-name", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_skill_add_with_no_name,
                manager_fixture_tear_down);

    g_test_add ("/manager/skill/add-with-duplicate-name", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_skill_add_with_duplicate_name,
                manager_fixture_tear_down);

    g_test_add ("/manager/skill/get", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_skill_get,
                manager_fixture_tear_down);

    g_test_add ("/manager/remove/ability", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_remove_ability,
                manager_fixture_tear_down);

    g_test_add ("/manager/remove/abilities", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_remove_abilities,
                manager_fixture_tear_down);

    g_test_add ("/manager/remove/skill", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_remove_skill,
                manager_fixture_tear_down);

    g_test_add ("/manager/remove/skills", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_remove_skills,
                manager_fixture_tear_down);

    g_test_add ("/manager/remove/all", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_remove_all,
                manager_fixture_tear_down);

    g_test_add ("/manager/signal/ability-score-changed-skill-score-changed", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_signal_ability_score_changed_skill_score_changed,
                manager_fixture_tear_down);

    g_test_add ("/manager/signal/skill-modifier-changed", ManagerFixture, NULL,
                manager_fixture_set_up,
                test_manager_signal_skill_modifier_changed,
                manager_fixture_tear_down);

    return g_test_run ();
}
